// Redline.cpp : Defines the entry point for the DLL application.
//

//#include "stdafx.h"
#include <Redline.h>
#include <verite.h>
#include <redline.h>
#include <vex.h>
#include  <rlfifoex.h>
#include <stdio.h>


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

typedef vl_error  (*VL_OpenVeriteT)(HWND hwnd, v_handle *pvhandle);
VL_OpenVeriteT pVL_OpenVerite=NULL;
typedef vl_error (*VL_CloseVeriteT) (v_handle vhandle);
VL_CloseVeriteT pVL_CloseVerite=NULL;
typedef vl_error (*VL_WaitForDisplaySwitchT)(v_cmdbuffer *cmdbuffer);
VL_WaitForDisplaySwitchT pVL_WaitForDisplaySwitch=NULL;
typedef vl_error (*VL_CreateSurfaceT)(v_handle vhandle, 
                                 v_surface **psurface, 
                                 v_u32 buffer_mask, 
                                 v_u32 num_buffers,
                                 v_u32 pixel_fmt, 
                                 v_u32 width, 
                                 v_u32 height);

VL_CreateSurfaceT pVL_CreateSurface=NULL;
typedef vl_error (*VL_DestroySurfaceT)(v_handle vhandle, v_surface *surface);
VL_DestroySurfaceT pVL_DestroySurface=NULL;

typedef vl_error (*VL_SwapDisplaySurfaceT)(v_cmdbuffer *cmdbuffer, v_surface *surface);
VL_SwapDisplaySurfaceT pVL_SwapDisplaySurface=NULL;

typedef vl_error (*VL_FillBufferT)(v_cmdbuffer *cmdbuffer,
			  v_surface *surface,
			  v_u32 buffer,
			  v_u32 xorg,
			  v_u32 yorg,
			  v_u32 width,
			  v_u32 height,
			  v_u32 pixel_value);
VL_FillBufferT pVL_FillBuffer=NULL;


typedef vl_error (*VL_LoadBufferT)(v_cmdbuffer *cmdbuffer,
			      v_surface *surface,
			      v_u32 buffer,
			      v_u32 data_linebytes,
			      v_u32 data_width,
			      v_u32 data_height,
			      v_memory data_memory, v_u32 *data_addr);
VL_LoadBufferT pVL_LoadBuffer=NULL;

typedef vl_error (*VL_InstallDstBufferT)(v_cmdbuffer *cmdbuffer, v_surface *surface);
VL_InstallDstBufferT pVL_InstallDstBuffer=NULL;

typedef vl_error (*VL_InstallTextureMapT)(v_cmdbuffer *cmdbuffer, v_surface *surface);
VL_InstallTextureMapT pVL_InstallTextureMap=NULL;

typedef vl_error (*VL_InstallZBufferT)(v_cmdbuffer *cmdbuffer, v_surface *surface);
VL_InstallZBufferT pVL_InstallZBuffer=NULL;


typedef vl_error (*VL_Setvu32T)(v_cmdbuffer *cmdbuffer, v_u32 src_base);
VL_Setvu32T pVL_SetSrcBase=NULL;

//typedef vl_error (*VL_SetSrcFilterT)(v_cmdbuffer *cmdbuffer, v_u32 src_filter);
VL_Setvu32T pVL_SetSrcFilter=NULL;
VL_Setvu32T pVL_SetSrcFunc=NULL;
VL_Setvu32T pVL_SetUMask=NULL, pVL_SetVMask=NULL;
VL_Setvu32T pVL_SetUMultiplier=NULL, pVL_SetVMultiplier=NULL;
VL_Setvu32T pVL_SetSrcStride=NULL;
VL_Setvu32T pVL_SetBlendSrcFunc=NULL, pVL_SetBlendDstFunc=NULL;
VL_Setvu32T pVL_SetZBufMode=NULL, pVL_SetZBufWrMode=NULL;
VL_Setvu32T pVL_SetBlendEnable=NULL, pVL_SetDitherEnable=NULL;
VL_Setvu32T pVL_SetFogEnable=NULL, pVL_SetTranspReject=NULL; 
VL_Setvu32T pVL_SetAlphaThreshold=NULL; 
VL_Setvu32T pVL_SetScissorX=NULL, pVL_SetScissorY=NULL; 
VL_Setvu32T pVL_SetFGColorARGB=NULL;
VL_Setvu32T pVL_SetFogColorRGB=NULL;
VL_Setvu32T pVL_SetZ=NULL;
VL_Setvu32T pVL_SetA=NULL;
VL_Setvu32T pVL_SetF=NULL;

typedef vl_error (*VL_RectangleT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 width, v_u32 height, v_u32 *vert);


typedef vl_error (*VL_TriangleT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 *v1, v_u32 *v2, v_u32 *v3);


typedef vl_error (*VL_TristripT)(v_cmdbuffer *cmdbuffer, v_u32 v_type, v_u32 tri_count, v_u32 *verts);

VL_RectangleT pVL_Rectangle=NULL;
VL_TriangleT pVL_Triangle=NULL;
VL_TristripT pVL_Tristrip=NULL, pVL_Trifan=NULL;

//typedef vl_error V_DLLIMPORT (*VL_SetMaskT)(v_cmdbuffer *cmdbuffer, v_u32 mask);
//typedef vl_error V_DLLIMPORT (*VL_SetVMaskT)(v_cmdbuffer *cmdbuffer, v_u32 u_mask);
//VL_SetUMask




/*// This is an example of an exported variable
REDLINE_API int nRedline=0;

// This is an example of an exported function.
REDLINE_API int fnRedline(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see Redline.h for the class definition
CRedline::CRedline()
{ 
	return; 
}*/

char tempBuff[1024];
size_t GetVertexSize(v_u32 v_type);

v_handle* pVhandle;
//vhandle = 0;
HWND hwnd;

v_cmdbuffer* cmdbuffer;
v_surface* surface;
v_u32 buffer;
v_u32 xorg;
v_u32 yorg;
v_u32 width;
v_u32 height;
v_u32 pixel_value;

v_handle vhandle;
v_surface** psurface;
v_u32 buffer_mask;
v_u32 num_buffers;
v_u32 pixel_fmt;

vl_error e;

v_u32 dither_enable;
v_u32 z_buf_wr_mode;
v_u32 z_buf_mode;
v_u32 blend_enable;
v_u32 transp_reject;
v_u32 blend_src_func;
v_u32 blend_dst_func;
v_u32 alpha_threshold;
v_u32 src_func;
v_u32 fog_color;
v_u32 fg_color;

v_u32 data_linebytes;
v_u32 data_width;
v_u32 data_height;
v_memory data_memory;
v_u32* data_addr;
v_memory memory;
v_u32 fog_enable;
v_u32 v_type;
v_u32* vert;
v_u32 src_filter;
v_u32 u_mult;
v_u32 v_mult;
v_u32 vert_count;
v_u32 *v1, *v2, *v3;

void LoadLibrary()
{
	char buff[MAX_PATH];
	GetSystemDirectory(buff, MAX_PATH);
	int len = strlen(buff);
	if(buff[len-1] != '\\')
		strcat(buff, "\\");
	strcat(buff, "Redline.dll");
	HMODULE hLib = LoadLibrary(buff);
	if( hLib)
	{
		pVL_OpenVerite = (VL_OpenVeriteT)GetProcAddress(hLib, "VL_OpenVerite");

		pVL_CloseVerite = (VL_CloseVeriteT)GetProcAddress(hLib, "VL_CloseVerite");

		pVL_WaitForDisplaySwitch = (VL_WaitForDisplaySwitchT)GetProcAddress(hLib, "VL_WaitForDisplaySwitch");

		pVL_CreateSurface = (VL_CreateSurfaceT)GetProcAddress(hLib, "VL_CreateSurface");

		pVL_DestroySurface = (VL_DestroySurfaceT) GetProcAddress(hLib, "VL_DestroySurface");

		pVL_SwapDisplaySurface = (VL_SwapDisplaySurfaceT) GetProcAddress(hLib, "VL_SwapDisplaySurface");

		pVL_FillBuffer= (VL_FillBufferT) GetProcAddress(hLib, "VL_FillBuffer");

		pVL_LoadBuffer = (VL_LoadBufferT) GetProcAddress(hLib, "VL_LoadBuffer");

		pVL_InstallDstBuffer = (VL_InstallDstBufferT) GetProcAddress(hLib, "VL_InstallDstBuffer");

		pVL_InstallTextureMap = (VL_InstallTextureMapT) GetProcAddress(hLib, "VL_InstallTextureMap");

		pVL_InstallZBuffer = (VL_InstallZBufferT) GetProcAddress(hLib, "VL_InstallZBuffer");

		pVL_SetSrcBase= (VL_Setvu32T) GetProcAddress(hLib, "VL_SetSrcBase");

		pVL_SetSrcFilter = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcFilter");

		pVL_SetSrcFunc = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcFunc");

		pVL_SetUMask = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetUMask");

		pVL_SetVMask = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetUVask");

		pVL_SetUMultiplier = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetUMultiplier");

		pVL_SetVMultiplier = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetVMultiplier");
		pVL_SetSrcStride = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetSrcStride");

		pVL_SetBlendSrcFunc = (VL_Setvu32T)GetProcAddress(hLib, "pVL_SetBlendSrcFunc");

		pVL_SetBlendDstFunc = (VL_Setvu32T)GetProcAddress(hLib, "SVL_etBlendDstFunc");

		pVL_SetZBufMode = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZBufMode");

		pVL_SetZBufWrMode = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZBufWrMode");
		

		pVL_SetBlendEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetBlendEnable");

		pVL_SetDitherEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetDitherEnable");


		pVL_SetFogEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFogEnable");

		pVL_SetTranspReject = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetTranspReject");


		pVL_SetAlphaThreshold = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetAlphaThreshold");

		pVL_SetFogEnable = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFogEnable");
		pVL_SetTranspReject = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetTranspReject");
		pVL_SetAlphaThreshold = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetAlphaThreshold");

		pVL_SetScissorX = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetScissorX");
		pVL_SetScissorY = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetScissorY");
		pVL_SetFGColorARGB = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFGColorARGB");

		pVL_SetFogColorRGB = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetFogColorRGB");
		pVL_SetZ = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetZ");
		pVL_SetA = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetA");
		pVL_SetF = (VL_Setvu32T)GetProcAddress(hLib, "VL_SetF");

		

		pVL_Rectangle = (VL_RectangleT)GetProcAddress(hLib, "VL_Rectangle");


		pVL_Triangle = (VL_TriangleT)GetProcAddress(hLib, "VL_Triangle");

		pVL_Tristrip = (VL_TristripT)GetProcAddress(hLib, "VL_Tristrip");
		pVL_Trifan = (VL_TristripT)GetProcAddress(hLib, "VL_Tristrip");

		
		
	}
	else
	{
		MessageBoxA(NULL, "LoadLibrary failed (system) Redline.dll", buff, MB_OK);
		exit(1);
	}


	//VL_OpenVerite = 
}


__declspec(naked) __declspec(dllexport) vl_error VL_OpenVerite_()
{
	
	//VLLOG("VL_OpenVerite_");
	//ELOG(std::format("VL_OpenVerite__ entry HWND {:08X}, microcode filename \"{}\"", (size_t)hwnd, microcode ? std::string(microcode) : std::string("")));
	//unsigned int *v13;
	//int Redx;
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
		mov hwnd, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov pVhandle, edx;
	}
	//VL("VL_OpenVerite_()");
	//std::vector<char> temp(256);
	//sprintf_s(temp.data(), temp.size(), "v%-4x3d.uc", *v13);
	//ELOG(std::format("HWND {:08X}, Microcode file is {}, EDX {:08X}, vhandle * {:08X}", (size_t)hwnd, temp.data(), Redx, (size_t)vhandle));
	//ELOG(std::format("v13 is {}", *v13));
	LoadLibrary();
	vl_error e;
	e = pVL_OpenVerite(hwnd, pVhandle);
	sprintf(tempBuff, "vhandle %08X, HWND %08X", (size_t)vhandle, (size_t)hwnd);
	//VL(tempBuff);
	//ELOG(std::format("vhandle * {:08X}, *vhandle* {:08X}", (size_t)vhandle, (size_t)*vhandle));
	//return e;
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
		//add esp, 0Ch;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_CloseVerite_()
{

	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}


	__asm {
		mov vhandle, eax;
	}

	//VL("VL_CloseVerite_");
	e = pVL_CloseVerite(vhandle);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_WaitForDisplaySwitch_()
{
	//v_cmdbuffer* cmdbuffer;
	__asm {
		mov cmdbuffer, eax;
	
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//VL("VL_WaitForDisplaySwitch_");
	//vl_error e;
	e =  pVL_WaitForDisplaySwitch(cmdbuffer);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_CreateSurface_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}


	__asm {
		mov vhandle, eax;
		mov psurface, edx;
		mov buffer_mask, ebx;
		mov num_buffers, ecx;
		

		mov eax, esp;
		mov ebx, [eax + 20];
		mov pixel_fmt, ebx;
		mov ebx, [eax + 24];
		mov width, ebx;
		mov ebx, [eax + 28];
		mov height, ebx;
	}
	/*sprintf_s(tempBuff, 1024, "VL_CreateSurface_ vhandle %08X, psurface %08X, mask %d, pixel_fmt %d, %dx%d", (size_t)vhandle, (size_t)psurface,
		buffer_mask, pixel_fmt, width, height);
	VL(tempBuff);*/
	//VLLOG("VL_CreateSurface_");
	
	e =  pVL_CreateSurface(vhandle,
		psurface,
		buffer_mask,
		num_buffers,
		pixel_fmt,
		width,
		height);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret 4 * 3;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_DestroySurface_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}


	__asm {
		mov vhandle, eax;
		mov surface, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_DestroySurface_ vhandle %08X, surface %08X", (size_t)vhandle, (size_t)surface);
	//VL(tempBuff);
	e = pVL_DestroySurface(vhandle, surface);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SwapDisplaySurface_()
{
	//v_cmdbuffer* cmdbuffer;
	//v_surface* surface;

	__asm {
		mov cmdbuffer, eax;
		mov surface, edx;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//VL("VL_SwapDisplaySurface_");
	e = pVL_SwapDisplaySurface(cmdbuffer, surface);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_FillBuffer_()
{

	__asm {

		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}



	__asm {

		mov cmdbuffer, eax;
		mov surface, edx;
		mov buffer, ebx;

		mov ebx, esp;
		mov ecx, [esp + 20];
		mov pixel_value, ecx;
		mov ecx, [esp + 24];
		mov width, ecx;
		mov ecx, [esp + 28];
		mov height, ecx;
		mov ecx, [esp + 32];
		mov xorg, ecx;
		//mov ecx, [esp + 36];
		//mov yorg, ecx;
	}
	yorg = xorg & 0xFFFF;
	xorg >>= 16;
	/*sprintf_s(tempBuff, 1024, "VL_FillBuffer_ cmdbuffer %08X, surface %08X, buffer %d,  (%d,%d)-(%d, %d), pixel %08X",
		(size_t)cmdbuffer, (size_t)surface, buffer, xorg, yorg, width, height, pixel_value);
	VL(tempBuff);*/

	e =  pVL_FillBuffer(cmdbuffer,
		surface,
		buffer,
		xorg,
		yorg,
		width,
		height,
		pixel_value);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret 4 * 4;
		//ret;
	}

}


__declspec(naked)  __declspec(dllexport) vl_error V_DLLIMPORT VL_LoadBuffer_()
{

	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}


	__asm {
		mov cmdbuffer, eax;
		mov surface, edx;
		mov data_linebytes, ecx;
		mov buffer, ebx;


		mov eax, esp;

		mov ebx, [eax + 32];
		mov data_addr, ebx;
		mov ebx, [eax + 28];
		mov memory, ebx;
		mov ebx, [eax + 24];
		mov data_height, ebx;
		mov ebx, [eax + 20];
		mov data_width, ebx;

	}
	/*if (cmdbuffer)
	{
		sprintf_s(tempBuff, 1024, "VL_LoadBuffer_ cmdbuffer %08X (%d), vsurf %08X, dims %ux%u, linebytes %u, memory %08X, address %08X",
			(size_t)cmdbuffer, (*cmdbuffer)->id, (size_t)surface, data_width, data_height, data_linebytes, (size_t)memory, (size_t)data_addr);
	}
	else
	{
		sprintf_s(tempBuff, 1024, "VL_LoadBuffer_ cmdbuffer %08X, vsurf %08X, dims %ux%u, linebytes %u, memory %08X, address %08X",
			(size_t)cmdbuffer, (size_t)surface, data_width, data_height, data_linebytes, (size_t)memory, (size_t)data_addr);
	}
	VL(tempBuff);
	if (surface)
	{
		if (surface->buffer_mask != 3)
			VL("VL_LoadBuffer_ Not primary surface");
		sprintf_s(tempBuff, 1024, "vsurface %ux%u, format %u, mask %u, num buffers %u", surface->width, surface->height,
			surface->pixel_fmt, surface->buffer_mask, surface->num_buffers);
		VL(tempBuff);
	}*/
	e = pVL_LoadBuffer(cmdbuffer,
		surface,
		buffer,
		data_linebytes,
		data_width,
		data_height,
		memory, data_addr);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret 4 * 4;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallDstBuffer_()
{
	

	__asm {
		mov cmdbuffer, eax;
		mov surface, edx;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallDstBuffer_ cmdbuffer %08X, v_surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	//vl_error e;
	e = pVL_InstallDstBuffer(cmdbuffer, surface);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallTextureMap_()
{
	__asm {
		mov surface, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallTextureMap_ cmdbuffer %08X, surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	////vl_error e;
	//e = VL_InstallZBuffer(cmdbuffer, surface);

	//VL("VL_InstallTextureMap_");

	e = pVL_InstallTextureMap(cmdbuffer, surface);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_InstallZBuffer_()
{
	//v_cmdbuffer* cmdbuffer;
	//v_surface* surface;
	__asm {
		mov surface, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_InstallZBuffer_ cmdbuffer %08X, surface %08X", (size_t)cmdbuffer, (size_t)surface);
	//VL(tempBuff);
	//vl_error e;
	e = pVL_InstallZBuffer(cmdbuffer, surface);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcBase_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetSrcBase_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetSrcBase(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcFunc_()
{


	__asm {
		mov src_func, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetSrcFunc_ %d", src_func);
	//VL(tempBuff);

	e = pVL_SetSrcFunc(cmdbuffer, src_func);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}



__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcFilter_()
{
	__asm {
		mov src_filter, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetSrcFilter_ %u", src_filter);
	//VL(tempBuff);
	e = pVL_SetSrcFilter(cmdbuffer, src_filter);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetUMask_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetUMask_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetUMask(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetVMask_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}

	//sprintf_s(tempBuff, 1024, "VL_SetVMask_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetVMask(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetUMultiplier_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetUMultiplier_ %u %f", u_mult, u_mult/65536.0f);
	//VL(tempBuff);
	e = pVL_SetUMultiplier(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetVMultiplier_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetVMultiplier_ %u, %f", u_mult, u_mult / 65536.0);
	//VL(tempBuff);
	e = pVL_SetVMultiplier(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetSrcStride_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetSrcStride_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetSrcStride(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetBlendSrcFunc_()
{
	

	__asm {
		mov blend_src_func, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetBlendSrcFunc_ %d", blend_src_func);
	//VL(tempBuff);
	
	e = pVL_SetBlendSrcFunc(cmdbuffer, blend_src_func);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetBlendDstFunc_()
{
	__asm {
		mov blend_dst_func, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}

	//sprintf_s(tempBuff, 1024, "VL_SetBlendDstFunc_ %d", blend_dst_func);
	//VL(tempBuff);

	e =  pVL_SetBlendDstFunc(cmdbuffer, blend_dst_func);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}



__declspec(naked) __declspec(dllexport) vl_error VL_SetZBufMode_()
{
		
	__asm {
		mov z_buf_mode, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetZBufMode_ cmdbuffer %08X,  mode  %d", (size_t) cmdbuffer, z_buf_mode);
	//VL(tempBuff);
	//vl_error e;
	e = pVL_SetZBufMode(cmdbuffer, z_buf_mode);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetZBufWrMode_()
{
	//v_cmdbuffer* cmdbuffer;
	

	__asm {
		mov z_buf_wr_mode, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetZBufWrMode_ cmdbuffer %08X, write mode %d", (size_t)cmdbuffer, z_buf_wr_mode);
	//VL(tempBuff);

	e = pVL_SetZBufWrMode(cmdbuffer, z_buf_wr_mode);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) vl_error __declspec(dllexport) VL_SetBlendEnable_()
{

	__asm {
		mov blend_enable, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetBlendEnable_ %d", blend_enable);
	//VL(tempBuff);

	e = pVL_SetBlendEnable(cmdbuffer, blend_enable);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetDitherEnable_()
{

	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov dither_enable, edx;

	}

	//VL("VL_SetDitherEnable_");

	//vl_error e;
	e = pVL_SetDitherEnable(cmdbuffer, dither_enable);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetFogEnable_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
		mov eax, cmdbuffer;
		mov fog_enable, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetFogEnable_ %u", fog_enable);
	//VL(tempBuff);
	e = pVL_SetFogEnable(cmdbuffer, fog_enable);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetTranspReject_()
{

	__asm {
		mov transp_reject, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetTranspReject_ %d", transp_reject);
	//VL(tempBuff);

	e = pVL_SetTranspReject(cmdbuffer, transp_reject);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) vl_error __declspec(dllexport) VL_SetAlphaThreshold_()
{
	

	__asm {
		mov alpha_threshold, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}

	//sprintf_s(tempBuff, 1024, "VL_SetAlphaThreshold_ %d", alpha_threshold);
	//VL(tempBuff);

	e =  pVL_SetAlphaThreshold(cmdbuffer, (v_u8)alpha_threshold);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetScissorX_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
		mov cmdbuffer, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov v_type, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetScissorX_ cmdbuffer %08X, scissor X %08X", (size_t)cmdbuffer, v_type);
	//VL(tempBuff);
	e = pVL_SetScissorX(cmdbuffer, v_type);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
		//add esp, 0Ch;
	}

}

__declspec(naked) __declspec(dllexport) vl_error VL_SetScissorY_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
		mov cmdbuffer, eax;
		//mov v13, esp;
		//mov Redx, edx;
		mov v_type, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetScissorY_ cmdbuffer %08X, scissor X %08X", (size_t)cmdbuffer, v_type);
	//VL(tempBuff);
	e = pVL_SetScissorY(cmdbuffer, v_type);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
		//add esp, 0Ch;
	}

	//VLLOG("VL_SetScissorY_");
	//return VL_SetScissorY(cmdbuffer, scissor_y);
}



__declspec(naked) __declspec(dllexport) vl_error VL_SetFGColorARGB_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}


	__asm {
		mov cmdbuffer, eax;
		mov fg_color, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetFGColorARGB_ %08X", fg_color);
	//VL(tempBuff);
	e = pVL_SetFGColorARGB(cmdbuffer, fg_color);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetFogColorRGB_()
{
	__asm	{
		mov fog_color, edx;
		mov cmdbuffer, eax;
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

	}
	//sprintf_s(tempBuff, 1024, "VL_SetFogColorRGB_ %08X", fog_color);
	//VL(tempBuff);
	e = pVL_SetFogColorRGB(cmdbuffer, fog_color);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_SetZ_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetZ_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetZ(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_SetA_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetA_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetA(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_SetF_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov u_mult, edx;
	}
	//sprintf_s(tempBuff, 1024, "VL_SetF_ %u", u_mult);
	//VL(tempBuff);
	e = pVL_SetF(cmdbuffer, u_mult);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error VL_Rectangle_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov width, ebx;
		mov height, ecx;
		mov eax, esp
		mov ebx, [eax + 20];
		mov vert, ebx;
	}
	//height >>= 16;
	//width >>= 16;
	//sprintf_s(tempBuff, 1024, "VL_Rectangle_ vtype %u, %ux%u, vert %08X", v_type, width>>16, height>>16, (size_t) vert);

	//VL(tempBuff);

	e = pVL_Rectangle(cmdbuffer, v_type, width, height, vert);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret 4 * 1;
	}

}


__declspec(naked) __declspec(dllexport) vl_error VL_Triangle_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;
	}

	//v_u32 EBP;
	__asm {
		mov v_type, edx;
		mov v1, ebx;
		mov cmdbuffer, eax;

		mov eax, esp
		mov ebx, [eax + 20];
		mov v3, ebx;
		//pop refresh_rate;


	}

	v2 = v1 + (GetVertexSize(v_type)>>2);
	//sprintf_s(tempBuff, 1024, "VL_Triangle_ vt %u, size %u,  v1 %08X, v2 %08X, v3 %08X, %u, %u, %u", v_type, GetVertexSize(v_type),
	//	(size_t)v1, (size_t)v2, (size_t)v3, (size_t)v1, (size_t)v2, (size_t)v3);
	//VL(tempBuff);
	e = pVL_Triangle(cmdbuffer, v_type, v1, v2, v3);
	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret 4;
		//ret;
	}
}


__declspec(naked) __declspec(dllexport) vl_error V_DLLIMPORT VL_Tristrip_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov vert_count, ebx;
		mov vert, ecx;
	}
	//sprintf_s(tempBuff, 1024, "VL_Tristrip_ type %u, num %u, verts %08X", v_type, vert_count, (size_t)vert);
	//VL(tempBuff);
	e = pVL_Tristrip(cmdbuffer, v_type, vert_count, vert);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}

__declspec(naked) __declspec(dllexport) vl_error VL_Trifan_()
{
	__asm {
		push    ebx;
		push    ecx;
		push    esi;
		push    edi;

		mov cmdbuffer, eax;
		mov v_type, edx;
		mov vert_count, ebx;
		mov vert, ecx;
	}
	//sprintf_s(tempBuff, 1024, "VL_Trifan_ type %u, num %u, verts %08X", v_type, vert_count, (size_t) vert);
	//VL(tempBuff);
	e = pVL_Trifan(cmdbuffer, v_type, vert_count, vert);

	__asm {
		mov eax, e;
		pop     edi;
		pop     esi;
		pop     ecx;
		pop     ebx;
		ret;
	}
}


__declspec(naked) __declspec(dllexport)vl_error VL_FrameMarker_()
{
	//VLLOG("VL_FrameMarker_");
	//ELOG("VL_FrameMarker_");
	__asm{
		mov eax, VL_SUCCESS;
		ret;
	}
}




size_t GetVertexSize(v_u32 v_type)
{
	//unsigned int size{};

	switch (v_type)
	{
	case V_FIFO_XY:
	{
		//LOG("V_FIFO_XY", 6);
		return sizeof(v_xy);// 8;

	}
	case V_FIFO_XYUV:
	{
		//LOG("V_FIFO_XYUV", 6);
		return sizeof(v_xyuv);// 16;
	}
	case V_FIFO_XYUVQ:
	{
		return sizeof(v_xyuvq);// 20;
		break;
	}
	case V_FIFO_IXYUVQ:
	{
		return sizeof(v_ixyuvq);
		break;
	}
	case V_FIFO_FXYUVQ:
	{
		return sizeof(v_fxyuvq); //24;
		break;
	}
	case V_FIFO_RGBFXY:
	{
		return sizeof(v_rgbfxy); //24;
		break;
	}
	case V_FIFO_XYZUVQ:
	{
		return sizeof(v_xyzuvq);
		break;
	}
	case V_FIFO_RGBXYZ:
	{
		//LOG("V_FIFO_XYZUVQ", 6);
		return sizeof(v_rgbxyz);//24;
		break;
	}
	case V_FIFO_IXYZUVQ:
	{
		return sizeof(v_ixyzuvq);;
		break;
	}
	case V_FIFO_IFXYUVQ:
	{
		return sizeof(v_ifxyuvq);// 7 * 4;
		break;
	}
	case V_FIFO_RGBAFXYUVQ:
	{

		return sizeof(v_rgbafxyuvq);
		break;
	}
	case V_FIFO_RGBAXYZUVQ:
	{
		return sizeof(v_rgbaxyzuvq);//; 4 * 10;
		break;
	}
	case V_FIFO_KAFXYUVQ:
	{
		return sizeof(v_kafxyuvq);// 4 * 8;
		break;
	}
	case V_FIFO_KFXY:
	{
		return sizeof(v_kfxy);
		break;
	}
	case V_FIFO_KXYZ:
	{
		return sizeof(v_kxyz);// 4 * 4;
		break;
	}
	case V_FIFO_KFXYZ:
	{
		return sizeof(v_kfxyz);// 4 * 4;
		break;

	}
	case V_FIFO_KXY:
	{

		return sizeof(v_kxy);;// 4 * 3;
		break;
	}
	case V_FIFO_KAFXYZUVQ:
	{
		return sizeof(v_kafxyzuvq);;// 9 * 4;
		break;
	}
	case V_FIFO_AXY:
	{
		return sizeof(v_axy);// 3 * 4;
		break;
	}
	case V_FIFO_KXYUVQ:
	{
		return sizeof(v_kxyuvq);//6 * 4;
		break;
	}
	case V_FIFO_FXYZ:
	{
		return sizeof(v_fxyz);// 4 * 4;
		break;
	}
	case V_FIFO_XYZ:
	{
		return sizeof(v_xyz);// 3 * 4;
		break;
	}
	case V_FIFO_KAXYZUVQ:
	{
		//LOG("V_FIFO_KAXYZUVQ", 6);
		return sizeof(v_kaxyzuvq);;// 32;
		break;
	}
	case V_FIFO_IXYZUV:
	{
		return sizeof(v_ixyzuv);// 4 * 5;
		break;
	}


	case V_FIFO_RGBAFXYZUVQ:
	{
		//LOG("V_FIFO_RGBAFXYZUVQ", 6);
		return sizeof(v_rgbafxyzuvq);// 44;
		break;
	}
	case V_FIFO_KSXYUVQ:
	{
		return sizeof(v_ksxyuvq);// 28;
		break;;
	}
	case V_FIFO_KSXYZUVQ:
	{
		return sizeof(v_ksxyzuvq);// 32;
		break;
	}
	case V_FIFO_KaSFXYZUVQ:
	{
		return sizeof(v_kasfxyzuvq);// 40;
		break;

	}
	default:
	{
		//ELOG(std::format("Unknown vertex size {}", v_type));
		return 0;
	}
	}
	return 0;

}
